set flowsdsp [lindex $argv 0]
set flowstcp [lindex $argv 1]
set queue [lindex $argv 2]
set type [lindex $argv 3]
set rate [lindex $argv 4]
set ecn [lindex $argv 5]
set increase [lindex $argv 6]
set decrease [lindex $argv 7]
set ecndsp [lindex $argv 8]
set ecntcp [lindex $argv 9]
set to [lindex $argv 10]
set randomflows [lindex $argv 11]
set thr [lindex $argv 12]
set bytes [lindex $argv 13]
set rl [lindex $argv 14]
set sowdp [lindex $argv 15]
set rate1 [lindex $argv 16]
set freq [lindex $argv 17]
set freq1 [lindex $argv 18]
set rnd [lindex $argv 19]


Agent/TCP set precisionReduce_ true
###sale Queue set limit_ 25
Queue set limit_ 2000
#sale puts "flows:$flows queue:$queue rate:$rate ecn:$ecn ecndsp:$ecndsp ecntcp: $ecntcp"

proc stop { tracefile1 } {
    close $tracefile1
    exit
}

proc printall { fmon } {
    global ecn queue
}

set stoptime 800

set ns [new Simulator]
#set tracefile [open  all.12.tr w]
set tracefile1 [open ./results-sale/web-$flowsdsp-$flowstcp-$queue$type-$rate-b$decrease-to$to-bk$randomflows-thr$thr-byt$bytes-rl$rl-sowdp$sowdp-rat1e$rate1-freq$freq w]


if { $rnd == 0 } {
# don't do anything - default
} else {
ns-random $rnd
}


source mhop2.tcl

create_topology

#set node_(r1) [$ns node]
#set node_(r2) [$ns node]
set node_(r1) $n(0)
set node_(r2) $n(1)
set node_(r3) $n(2)
set node_(r4) $n(3)




Queue/RED set gentle_ true

#Packs vs. bytes
if { $bytes == 1} {
Queue/RED set bytes_ true
Queue/RED set queue_in_bytes_ true
Queue/RED set mean_pksize_ 1000
}


###old_ecn Queue/RED set gentle_ false
Queue/RED set setbit_ false
Agent/TCP set ecn_ 0
if {$ecn==1} {
  Queue/RED set setbit_ true
Agent/TCP set ecn_ 1
###old_ecn Agent/TCP set old_ecn_ 1
}




#sale

  Agent/TCP set to_inference_ $to

if { $rl == 0 } {
  Agent/TCP set rl_ 0
} elseif { $rl == 1 } {
  Agent/TCP set rl_ [expr 0.0008/$rate]
} else {
  Agent/TCP set rl_ $rl
}



if { $thr == 0 } {
  Agent/TCP set owd_opt_ 0
} else {
  Agent/TCP set owd_opt_ 1
  Agent/TCP set thr_perc_ $thr
}
  Agent/TCP set sowd_param_ $sowdp

#end sale


$ns duplex-link $node_(r1) $node_(r2) [set rate]Mb 20ms $queue
source queueSizeSale.tcl
setQueueSize $rate $queue $node_(r1) $node_(r2) $type $bytes


$ns duplex-link $node_(r2) $node_(r3) [set rate]Mb 20ms $queue
source queueSizeSale.tcl
setQueueSize $rate $queue $node_(r2) $node_(r3) $type $bytes

$ns duplex-link $node_(r3) $node_(r4) [set rate]Mb 20ms $queue
source queueSizeSale.tcl
setQueueSize $rate $queue $node_(r3) $node_(r4) $type $bytes



if { $rate == 1.5 } {
$ns queue-limit $node_(r1) $node_(r2) 25
$ns queue-limit $node_(r2) $node_(r1) 25

$ns queue-limit $node_(r2) $node_(r3) 25
$ns queue-limit $node_(r3) $node_(r2) 25

$ns queue-limit $node_(r3) $node_(r4) 25
$ns queue-limit $node_(r4) $node_(r3) 25



} elseif {$rate == 10 } {

$ns queue-limit $node_(r1) $node_(r2) 166
$ns queue-limit $node_(r2) $node_(r1) 166

$ns queue-limit $node_(r2) $node_(r3) 166
$ns queue-limit $node_(r3) $node_(r2) 166

$ns queue-limit $node_(r3) $node_(r4) 166
$ns queue-limit $node_(r4) $node_(r3) 166


# I am not going down any more because I am doing only with 1.5 Mbps so far

    set redq [[$ns link $node_(r1) $node_(r2)] queue]
    set redq1 [[$ns link $node_(r2) $node_(r1)] queue]
	    $redq1 set thresh_ 166000
            $redq1 set maxthresh_ 166000
            $redq1 set linterm_ 10

#original is 3 and 13 - SALE

	   if { $bytes == 0 } {

	    if { $type == 0 } {
            $redq set thresh_ 0
            $redq set maxthresh_ 0
            $redq set linterm_ 10

	    } elseif { $type == 1 } {
            $redq set thresh_ 6
            $redq set maxthresh_ 6
            $redq set linterm_ 10

	    } elseif { $type == 2 } {
            $redq set thresh_ 13
            $redq set maxthresh_ 13
            $redq set linterm_ 10

	    } elseif { $type == 3 } {
            $redq set thresh_ 19
            $redq set maxthresh_ 19
            $redq set linterm_ 10

	    } elseif { $type == 4 } {
            $redq set thresh_ 26
            $redq set maxthresh_ 26
            $redq set linterm_ 10

	    } elseif { $type == 5 } {
            $redq set thresh_ 33
            $redq set maxthresh_ 33
            $redq set linterm_ 10

	    } elseif { $type == 13 } {
            $redq set thresh_ 86
            $redq set maxthresh_ 86
            $redq set linterm_ 10

	    } elseif { $type == 14 } {
            $redq set thresh_ 92
            $redq set maxthresh_ 92
            $redq set linterm_ 10

	    } elseif { $type == 16 } {
            $redq set thresh_ 105
            $redq set maxthresh_ 105
            $redq set linterm_ 10

	    } elseif { $type == 18 } {
            $redq set thresh_ 119
            $redq set maxthresh_ 119
            $redq set linterm_ 10

	    } elseif { $type == 22 } {
            $redq set thresh_ 145
            $redq set maxthresh_ 145
            $redq set linterm_ 10

	    } elseif { $type == 25 } {
            $redq set thresh_ 166
            $redq set maxthresh_ 166
            $redq set linterm_ 10

	    } elseif { $type == 313 } {
            $redq set thresh_ 20
            $redq set maxthresh_ 86
            $redq set linterm_ 10

	    } elseif { $type == 15 } {
            $redq set thresh_ 6
            $redq set maxthresh_ 33
            $redq set linterm_ 10

	    } else {
	    $redq set thresh_ 20
            $redq set maxthresh_ 86
            $redq set linterm_ 10
	    }
	} else {
	    # bytes == 1
	    if { $type == 0 } {
            $redq set thresh_ 0
            $redq set maxthresh_ 0
            $redq set linterm_ 10

	    } elseif { $type == 1 } {
            $redq set thresh_ 6000
            $redq set maxthresh_ 6000
            $redq set linterm_ 10

	    } elseif { $type == 2 } {
            $redq set thresh_ 13000
            $redq set maxthresh_ 13000
            $redq set linterm_ 10

	    } elseif { $type == 3 } {
            $redq set thresh_ 19000
            $redq set maxthresh_ 19000
            $redq set linterm_ 10

	    } elseif { $type == 4 } {
            $redq set thresh_ 26000
            $redq set maxthresh_ 26000
            $redq set linterm_ 10

	    } elseif { $type == 5 } {
            $redq set thresh_ 33000
            $redq set maxthresh_ 33000
            $redq set linterm_ 10

	    } elseif { $type == 13 } {
            $redq set thresh_ 86000
            $redq set maxthresh_ 86000
            $redq set linterm_ 10

	    } elseif { $type == 14 } {
            $redq set thresh_ 92000
            $redq set maxthresh_ 92000
            $redq set linterm_ 10

	    } elseif { $type == 16 } {
            $redq set thresh_ 105000
            $redq set maxthresh_ 105000
            $redq set linterm_ 10

	    } elseif { $type == 18 } {
            $redq set thresh_ 119000
            $redq set maxthresh_ 119000
            $redq set linterm_ 10

	    } elseif { $type == 22 } {
            $redq set thresh_ 145000
            $redq set maxthresh_ 145000
            $redq set linterm_ 10

	    } elseif { $type == 25 } {
            $redq set thresh_ 166000
            $redq set maxthresh_ 166000
            $redq set linterm_ 10

	    } elseif { $type == 313 } {
            $redq set thresh_ 20000
            $redq set maxthresh_ 86000
            $redq set linterm_ 10

	    } elseif { $type == 15 } {
            $redq set thresh_ 6000
            $redq set maxthresh_ 33000
            $redq set linterm_ 10

	    } else {
	    $redq set thresh_ 20000
            $redq set maxthresh_ 86000
            $redq set linterm_ 10
	    }
	}

}





$ns trace-queue $n(3) $n(9) $tracefile1
$ns trace-queue $n(3) $n(10) $tracefile1
$ns trace-queue $n(3) $n(11) $tracefile1
$ns trace-queue $n(3) $n(12) $tracefile1
$ns trace-queue $n(3) $n(13) $tracefile1


$ns trace-queue $n(9) $n(3) $tracefile1
$ns trace-queue $n(10) $n(3) $tracefile1
$ns trace-queue $n(11) $n(3) $tracefile1
$ns trace-queue $n(12) $n(3) $tracefile1
$ns trace-queue $n(13) $n(3) $tracefile1


#$ns trace-all $tracefile

#sale

if {$rate < 15 } {
#set dsptr [open "./results-sale/dsp-$flowsdsp-$flowstcp-$queue$type-$rate-b$decrease-to$to-bk$randomflows-thr$thr-byt$bytes-rl$rl-sowdp$sowdp-rat1e$rate1-freq$freq" w]
#set tcptr [open "./results-sale/tcp-$flowsdsp-$flowstcp-$queue$type-$rate-b$decrease-to$to-bk$randomflows-thr$thr-byt$bytes-rl$rl-sowdp$sowdp-rat1e$rate1-freq$freq" w]
}
#end sale



#set wndtr [open "|./getcwnd tcp1 0 75" w]
### # Set up DSP connection


  for {set i 0} {$i < 3} {incr i} {
     set node_(s$i) [$ns node]
     set node_(k$i) [$ns node]

   if { $i == 0} {
     $ns duplex-link $node_(s$i) $node_(r1) 100Mb 2ms DropTail
     $ns duplex-link $node_(k$i) $node_(r2) 100Mb [expr $i/3]ms DropTail
      }

    if { $i == 1} {
     $ns duplex-link $node_(s$i) $node_(r2) 100Mb 2ms DropTail
     $ns duplex-link $node_(k$i) $node_(r3) 100Mb [expr $i/3]ms DropTail
      }

    if { $i == 2} {
     $ns duplex-link $node_(s$i) $node_(r3) 100Mb 2ms DropTail
     $ns duplex-link $node_(k$i) $node_(r4) 100Mb [expr $i/3]ms DropTail
      }

if { $flowsdsp > 0 } {

set poly$i [$ns create-connection TCP/Reno $node_(s$i) TCPSink $node_(k$i) 0]
     [set poly$i] set window_ 128
     [set poly$i] set timestamps_ 1
     [set poly$i] set ts_echo_bugfix_ 1
     [set poly$i] set windowOption_ 10
     [set poly$i] set decrease_num_ $decrease
     [set poly$i] set k_parameter_ 2
     [set poly$i] set packetSize_ 999
     [set poly$i] set ecn_ $ecndsp
if { $rate < 15 } {
##     [set poly$i] attach $dsptr
##     [set poly$i] trace cwnd_
 #     [set poly$i] trace rtt_
 #     [set poly$i] trace srtt_
}
      [set poly$i] set ndatapack_ 0
    set sf$i [[set poly$i] attach-app FTP]
    set sec [expr $i/10]
    set frac [expr $i%10]
    set starttime $sec.$frac
      if {$i == 0} {
   	  $ns at $starttime "[set sf$i] start"
	  $ns at $stoptime "[set sf$i] stop"
      } else {
	  $ns at $starttime "[set sf$i] start"
	  $ns at $stoptime "[set sf$i] stop"
      }
  }
}




 for {set i 0} {$i < 3} {incr i} {
     set node_(ts$i) [$ns node]
     set node_(tk$i) [$ns node]


     if {$i == 0} {
     $ns duplex-link $node_(ts$i) $node_(r1) 100Mb 2ms DropTail
     $ns duplex-link $node_(tk$i) $node_(r2) 100Mb [expr $i/3]ms DropTail
     }

     if {$i == 1} {
     $ns duplex-link $node_(ts$i) $node_(r2) 100Mb 2ms DropTail
     $ns duplex-link $node_(tk$i) $node_(r3) 100Mb [expr $i/3]ms DropTail
     }

     if {$i == 2} {
     $ns duplex-link $node_(ts$i) $node_(r3) 100Mb 2ms DropTail
     $ns duplex-link $node_(tk$i) $node_(r4) 100Mb [expr $i/3]ms DropTail
     }


if { $flowstcp > 0 } {
 #    $ns duplex-link $node_(tk$i) $node_(r2) 100Mb [expr $i*5]ms DropTail
 #    set tcp$i [$ns create-connection TCP/Sack1 $node_(ts$i) TCPSink/Sack1 $node_(tk$i) 0]
 #    set tcp$i [$ns create-connection TCP/Newreno $node_(ts$i) TCPSink $node_(tk$i) 0]
 set tcp$i [$ns create-connection TCP/Reno $node_(ts$i) TCPSink $node_(tk$i) 0]
     [set tcp$i] set window_ 128
     [set tcp$i] set packetSize_ 1000
     [set tcp$i] set ecn_ $ecntcp
if { $rate < 15 } { 
##     [set tcp$i] attach $tcptr
##      [set tcp$i] trace cwnd_
 #     [set tcp$i] trace rtt_ 
 #     [set tcp$i] trace srtt_ 
 #     [set tcp$i] trace rttvar_
}
     [set tcp$i] set ndatapack_ 0
 
    set sec [expr $i/10]
    set frac [expr $i%10]
    set starttime $sec.$frac

     set ftp$i [[set tcp$i] attach-app FTP]

#      $ns at 100 "[set ftp$i] start"
#      $ns at 200 "[set ftp$i] stop"
#     $ns at 300 "[set ftp$i] start"
#     $ns at 400 "[set ftp$i] stop"
     $ns at $starttime "[set ftp$i] start"
     $ns at $stoptime "[set ftp$i] stop"
  }
 }


 # original -> set randomflows 4
#  set randomflows 0
#  if {$randomflows > $flowsdsp} {
#     set randomflows $flowsdsp
#  }

#  for {set i 0} {$i < $randomflows} {incr i} {
for {set i 0} {$i < 0} {incr i} {

set node_(tsal$i) [$ns node]
set node_(tkal$i) [$ns node]
     $ns duplex-link $node_(tsal$i) $node_(r1) 100Mb 2ms DropTail
#     $ns duplex-link $node_(tsal$i) $node_(r1) 100Mb 0ms DropTail
     $ns duplex-link $node_(tkal$i) $node_(r2) 100Mb [expr $i/3]ms DropTail 
set tccp$i [$ns create-connection TCP/Reno $node_(tkal$i) TCPSink $node_(tsal$i) 0]
[set tccp$i] set ecn_ 0
set ftp$i [[set tccp$i] attach-app FTP]
 $ns at $i "[set ftp$i] start"
#  $ns at 100 "[set ftp$i] start"
  $ns at $stoptime "[set ftp$i] stop"
#    $ns at 300 "[set ftp$i] stop"
#  $ns at 700  "[set ftp$i] start"
#  $ns at 800 "[set ftp$i] stop"
  
  }



#CBR

#if {$freq > 0} {
#
#set len [string length $rate]
#set rate_w_mb [string range $rate 0 [expr $len-3]]
#set len [string length $rate1]
#set rate1_w_mb [string range $rate1 0 [expr $len-3]]
#
##configure cbr source
##Application/Traffic/CBR set rate_ [expr $rate_w_mb-$rate1_w_mb]Mb
#Application/Traffic/CBR set rate_ [expr $rate*0.66]Mb
##puts "cbr rate [Application/Traffic/CBR set rate_]"
#set udp0 [new Agent/UDP]
#set node_(scbr) [$ns node]
#set node_(kcbr) [$ns node]
#$ns duplex-link $node_(scbr) $node_(r1) 100Mb 2ms DropTail
#$ns duplex-link $node_(kcbr) $node_(r2) 100Mb 2ms DropTail
#$ns attach-agent $node_(scbr) $udp0
#set cbr(0) [new Application/Traffic/CBR]
#$cbr(0) attach-agent $udp0
#set null0 [new Agent/Null]
#$ns attach-agent $node_(kcbr) $null0
#$ns connect $udp0 $null0         
#
#proc changebw {} {
#    global ns freq freq1 node_ rate rate1 queue fmon drop1 dep1 drop2 dep2 cbr
##    puts "changebw called"
#    $ns at [expr [$ns now]+$freq1] "$cbr(0) start"
#    $ns at [expr [$ns now]+$freq+$freq1] "changebw"
#    $ns at [expr [$ns now]+$freq+$freq1] "$cbr(0) stop"
#}         
#
#$ns at 0.0 "changebw"  
#}


#WEB TRAFFIC

set pool [new PagePool/WebTraf]

# Set up server and client nodes
$pool set-num-client [llength [$ns set src_]]
$pool set-num-server [llength [$ns set dst_]]
global n
set i 0
foreach s [$ns set src_] {
	$pool set-client $i $n($s)
	incr i
}
set i 0
foreach s [$ns set dst_] {
	$pool set-server $i $n($s)
	incr i
}




# Number of Sessions
set numSession 100

# Inter-session Interval
set interSession [new RandomVariable/Exponential]
$interSession set avg_ 10

## Number of Pages per Session
set sessionSize [new RandomVariable/Constant]
$sessionSize set val_ 10

# Random seed at every run
###global defaultRNG
###$defaultRNG seed 0

# Create sessions
$pool set-num-session $numSession
set launchTime 0
for {set i 0} {$i < $numSession} {incr i} {
	set numPage [$sessionSize value]
#	puts "Session $i has $numPage pages"
	set interPage [new RandomVariable/Exponential]
	$interPage set avg_ 1
	set pageSize [new RandomVariable/Constant]
	$pageSize set val_ 10
	set interObj [new RandomVariable/Exponential]
	$interObj set avg_ 0.01
	set objSize [new RandomVariable/ParetoII]
	$objSize set avg_ 10
	$objSize set shape_ 1.2
	$pool create-session $i $numPage [expr $launchTime + 0.1] \
			$interPage $pageSize $interObj $objSize
	set launchTime [expr $launchTime + [$interSession value]]
}














#this is dsp3 - begin
#### Number of Pages per Session
###set numPage 1
####sale 10 is original
###
#### Session 0 starts from 0.1s, session 1 starts from 0.2s
###$pool set-num-session 2
###
#### XXX Can't initialize instvars using something like this:
#### set interPage [new RandomVariable/Exponential -avg_ 1]
#### Must explicitly set variable values
###set interPage [new RandomVariable/Exponential] 
###$interPage set avg_ 1
###set pageSize [new RandomVariable/Constant]
###$pageSize set val_ 1
###set interObj [new RandomVariable/Exponential]
###$interObj set avg_ 0.1
####original is interObj set avg_ 0.1
###set objSize [new RandomVariable/ParetoII]
###$objSize set avg_ 10
###$objSize set shape_ 1.2
####$pool create-session 0 $numPage 0.1 $interPage $pageSize $interObj $objSize
###
###set interPage [new RandomVariable/Exponential]
###$interPage set avg_ 1
###set pageSize [new RandomVariable/Constant]
###$pageSize set val_ 10000
####it was PageSize set val_5 :gives OK results
###set interObj [new RandomVariable/Exponential]
###$interObj set avg_ 0.1
###set objSize [new RandomVariable/ParetoII]
###$objSize set avg_ 10
####original is  objSize set avg_ 10
###$objSize set shape_ 1.2
###$pool create-session 1 $numPage 10.0 $interPage $pageSize $interObj $objSize
###the end of dsp3






### $ns at 15 "$fmon set pdrops_ 0; $fmon set pdepartures_ 0"
#$ns at 15 "start_counting"


if { $flowsdsp > 0 } {
 for {set i 0} {$i < 3} {incr i} {
 $ns at 15 "[set poly$i] set ndatapack_ 0"
 }
}

if { $flowstcp > 0 } {
 for {set i 0} {$i < 3} {incr i} {
 $ns at 15 "[set tcp$i] set ndatapack_ 0"
 }
}

$ns at $stoptime "finish"

###$ns at $stoptime "printall $fmon; stop  $tracefile1"
$ns at $stoptime "stop $tracefile1"
#$acktrace $wndtr"



proc start_counting {} {
	global poly0 poly1
	$poly0 set ndatapack_ 0
	$poly1 set ndatapack_ 0
}



proc finish {} {

global ns flowsdsp flowstcp rnd
global poly0 poly1 poly2 poly3 poly4 poly5 poly6 poly7 poly8 poly9
global tcp0 tcp1 tcp2 tcp3 tcp4 tcp5 tcp6 tcp7 tcp8 tcp9
global data0 data1 data2 data3 data4 data5 data6 data7 data8 data9
$ns flush-trace

##$ns at 15 "$fmon set pdrops_ 0; $fmon set pdepartures_ 0"
##$ns at $stoptime "printall $fmon; stop $tracefile"
#$acktrace $wndtr"

    if { $flowsdsp > 0 } {
set sum 0.0
set data0 0.0
set data1 0.0
set data2 0.0
set data3 0.0
set data4 0.0
set data5 0.0
set data6 0.0
set data7 0.0
set data8 0.0
set data9 0.0

set file [open ./results-sale/xmit-$flowsdsp-$flowstcp "a+"]

     for {set i 0} {$i < 3} {incr i} {
	set data [[set poly$i] set ndatapack_]
set sum [expr $sum+$data]
set data$i $data
#	puts "$i xmitted $data"
puts $file "rnd $rnd $i xmitted $data"
     }
        if { $flowsdsp > 0 } {
#        puts "---TCP-LP totally xmitted $sum  packets ..."
puts $file "rnd $rnd t xmitted $sum"
set sumd 0.0
set sumu 0.0      
	for {set i 0} {$i < 3} {incr i} {
	set data$i [expr [set data$i]/$sum]
	set sumd [expr $sumd+[set data$i]*[set data$i]]
	set sumu [expr $sumu + [set data$i]]
	}	
	set fi [expr $sumu/(3*$sumd)]
#        puts "---TCP-LP fairness index: $fi"
 puts $file "rnd $rnd t fairind $fi"
	}
close $file
    }


    if { $flowstcp > 0 } {
set sum 0.0
set data0 0.0
set data1 0.0
set data2 0.0
set data3 0.0
set data4 0.0
set data5 0.0
set data6 0.0
set data7 0.0
set data8 0.0
set data9 0.0

set file [open ./results-sale/xmit-$flowsdsp-$flowstcp "a+"]

     for {set i 0} {$i < 3} {incr i} {
	set data [[set tcp$i] set ndatapack_]
set sum [expr $sum+$data]
set data$i $data
#	puts "$i xmitted $data"
puts $file "rnd $rnd $i xmitted $data"
     }
        if { $flowstcp > 0 } {
#        puts "---TCP totally xmitted $sum  packets ..."
puts $file "rnd $rnd t xmitted $sum"
set sumd 0.0
set sumu 0.0  
	for {set i 0} {$i < 3} {incr i} {
	set data$i [expr [set data$i]/$sum]
	set sumd [expr $sumd+[set data$i]*[set data$i]]
	set sumu [expr $sumu + [set data$i]]
	}	
	set fi [expr $sumu/(3*$sumd)]
#        puts "---TCP fairness index: $fi"
 puts $file "rnd $rnd t fairind $fi"
	}
close $file
    }

if { $rnd == 1 } {
    if { ($flowsdsp > 0) || ($flowstcp > 0)  } {
 set file [open ./results-sale/avg-xmit "a+"]
 puts $file "a.out 3 ./xmit-$flowsdsp-$flowstcp a ./xmit 1"
 close $file
    }
}

        exit 0
}
 




$ns run
















