set flowsdsp [lindex $argv 0]
set flowstcp [lindex $argv 1]
set queue [lindex $argv 2]
set type [lindex $argv 3]
set rate [lindex $argv 4]
set ecn [lindex $argv 5]
set increase [lindex $argv 6]
set decrease [lindex $argv 7]
set ecndsp [lindex $argv 8]
set ecntcp [lindex $argv 9]
set to [lindex $argv 10]
set randomflows [lindex $argv 11]
set thr [lindex $argv 12]
set bytes [lindex $argv 13]
set rl [lindex $argv 14]
set sowdp [lindex $argv 15]
set rate1 [lindex $argv 16]
set freq [lindex $argv 17]
set freq1 [lindex $argv 18]
set rnd [lindex $argv 19]


Agent/TCP set precisionReduce_ true
Queue set limit_ 2000

proc stop { tracefile } {
    close $tracefile
    exit
}


set stoptime 1000

set ns [new Simulator]
#set tracefile [open all.12.tr w]
#set acktrace [open ack.12.tr w]
#$ns trace-all $tracefile


if { $rnd == 0 } {
# don't do anything - default
} else {
ns-random $rnd
}


set node_(r1) [$ns node]
set node_(r2) [$ns node]





Queue/RED set gentle_ true

#Packs vs. bytes
if { $bytes == 1} {
Queue/RED set bytes_ true
Queue/RED set queue_in_bytes_ true
Queue/RED set mean_pksize_ 1000
}


###old_ecn Queue/RED set gentle_ false
Queue/RED set setbit_ false
Agent/TCP set ecn_ 0
if {$ecn==1} {
  Queue/RED set setbit_ true
Agent/TCP set ecn_ 1
###old_ecn Agent/TCP set old_ecn_ 1
}




Agent/TCP set to_inference_ $to

if { $rl == 0 } {
  Agent/TCP set rl_ 0
} elseif { $rl == 1 } {
  Agent/TCP set rl_ [expr 0.0008/$rate]
} else {
  Agent/TCP set rl_ $rl
}



if { $thr == 0 } {
  Agent/TCP set owd_opt_ 0
} else {
  Agent/TCP set owd_opt_ 1
  Agent/TCP set thr_perc_ $thr
}
  Agent/TCP set sowd_param_ $sowdp


$ns duplex-link $node_(r1) $node_(r2) [set rate]Mb 20ms $queue
source queueSizeSale.tcl
setQueueSize $rate $queue $node_(r1) $node_(r2) $type $bytes


if { $rate == 1.5 } {
$ns queue-limit $node_(r1) $node_(r2) 125
$ns queue-limit $node_(r2) $node_(r1) 125


} elseif {$rate == 10 } {

$ns queue-limit $node_(r1) $node_(r2) 166
$ns queue-limit $node_(r2) $node_(r1) 166


    set redq [[$ns link $node_(r1) $node_(r2)] queue]
    set redq1 [[$ns link $node_(r2) $node_(r1)] queue]
	    $redq1 set thresh_ 166000
            $redq1 set maxthresh_ 166000
            $redq1 set linterm_ 10

#original is 3 and 13 - SALE

	   if { $bytes == 0 } {

	    if { $type == 0 } {
            $redq set thresh_ 0
            $redq set maxthresh_ 0
            $redq set linterm_ 10

	    } elseif { $type == 1 } {
            $redq set thresh_ 6
            $redq set maxthresh_ 6
            $redq set linterm_ 10

	    } elseif { $type == 2 } {
            $redq set thresh_ 13
            $redq set maxthresh_ 13
            $redq set linterm_ 10

	    } elseif { $type == 3 } {
            $redq set thresh_ 19
            $redq set maxthresh_ 19
            $redq set linterm_ 10

	    } elseif { $type == 4 } {
            $redq set thresh_ 26
            $redq set maxthresh_ 26
            $redq set linterm_ 10

	    } elseif { $type == 5 } {
            $redq set thresh_ 33
            $redq set maxthresh_ 33
            $redq set linterm_ 10

	    } elseif { $type == 13 } {
            $redq set thresh_ 86
            $redq set maxthresh_ 86
            $redq set linterm_ 10

	    } elseif { $type == 14 } {
            $redq set thresh_ 92
            $redq set maxthresh_ 92
            $redq set linterm_ 10

	    } elseif { $type == 16 } {
            $redq set thresh_ 105
            $redq set maxthresh_ 105
            $redq set linterm_ 10

	    } elseif { $type == 18 } {
            $redq set thresh_ 119
            $redq set maxthresh_ 119
            $redq set linterm_ 10

	    } elseif { $type == 22 } {
            $redq set thresh_ 145
            $redq set maxthresh_ 145
            $redq set linterm_ 10

	    } elseif { $type == 25 } {
            $redq set thresh_ 166
            $redq set maxthresh_ 166
            $redq set linterm_ 10

	    } elseif { $type == 313 } {
            $redq set thresh_ 20
            $redq set maxthresh_ 86
            $redq set linterm_ 10

	    } elseif { $type == 15 } {
            $redq set thresh_ 6
            $redq set maxthresh_ 33
            $redq set linterm_ 10

	    } else {
	    $redq set thresh_ 20
            $redq set maxthresh_ 86
            $redq set linterm_ 10
	    }
	} else {
	    # bytes == 1
	    if { $type == 0 } {
            $redq set thresh_ 0
            $redq set maxthresh_ 0
            $redq set linterm_ 10

	    } elseif { $type == 1 } {
            $redq set thresh_ 6000
            $redq set maxthresh_ 6000
            $redq set linterm_ 10

	    } elseif { $type == 2 } {
            $redq set thresh_ 13000
            $redq set maxthresh_ 13000
            $redq set linterm_ 10

	    } elseif { $type == 3 } {
            $redq set thresh_ 19000
            $redq set maxthresh_ 19000
            $redq set linterm_ 10

	    } elseif { $type == 4 } {
            $redq set thresh_ 26000
            $redq set maxthresh_ 26000
            $redq set linterm_ 10

	    } elseif { $type == 5 } {
            $redq set thresh_ 33000
            $redq set maxthresh_ 33000
            $redq set linterm_ 10

	    } elseif { $type == 13 } {
            $redq set thresh_ 86000
            $redq set maxthresh_ 86000
            $redq set linterm_ 10

	    } elseif { $type == 14 } {
            $redq set thresh_ 92000
            $redq set maxthresh_ 92000
            $redq set linterm_ 10

	    } elseif { $type == 16 } {
            $redq set thresh_ 105000
            $redq set maxthresh_ 105000
            $redq set linterm_ 10

	    } elseif { $type == 18 } {
            $redq set thresh_ 119000
            $redq set maxthresh_ 119000
            $redq set linterm_ 10

	    } elseif { $type == 22 } {
            $redq set thresh_ 145000
            $redq set maxthresh_ 145000
            $redq set linterm_ 10

	    } elseif { $type == 25 } {
            $redq set thresh_ 166000
            $redq set maxthresh_ 166000
            $redq set linterm_ 10

	    } elseif { $type == 313 } {
            $redq set thresh_ 20000
            $redq set maxthresh_ 86000
            $redq set linterm_ 10

	    } elseif { $type == 15 } {
            $redq set thresh_ 6000
            $redq set maxthresh_ 33000
            $redq set linterm_ 10

	    } else {
	    $redq set thresh_ 20000
            $redq set maxthresh_ 86000
            $redq set linterm_ 10
	    }
	}







}





#set wndtr [open "|./getcwnd tcp1 0 75" w]





###Set up DSP flows

#if { $flowsdsp > 0 } {
  for {set i 0} {$i < $flowsdsp} {incr i} {
     set node_(s$i) [$ns node]
     set node_(k$i) [$ns node]
     $ns duplex-link $node_(s$i) $node_(r1) 100Mb 2ms DropTail
     $ns duplex-link $node_(k$i) $node_(r2) 100Mb [expr $i/3]ms DropTail

if { $flowsdsp > 0 } {

set poly$i [$ns create-connection TCP/Reno $node_(s$i) TCPSink $node_(k$i) 0]

     [set poly$i] set window_ 128
     [set poly$i] set timestamps_ 1
     [set poly$i] set ts_echo_bugfix_ 1
 
 #TCP_LP
     [set poly$i] set windowOption_ 10
 #end TCP_LP
     [set poly$i] set decrease_num_ $decrease
     [set poly$i] set k_parameter_ 2
     [set poly$i] set packetSize_ 999
 #TCP_LP
     [set poly$i] set ecn_ $ecndsp
if { $rate < 15 } {
 #    [set poly$i] attach $dsptr
 #    [set poly$i] trace cwnd_
 #     [set poly$i] trace rtt_
 #     [set poly$i] trace srtt_
}
      [set poly$i] set ndatapack_ 0
  #end TCP_LP
    set sf$i [[set poly$i] attach-app FTP]
    set sec [expr $i/10]
    set frac [expr $i%10]
    set starttime $sec.$frac
      if {$i == 0} {
   	  $ns at $starttime "[set sf$i] start"
	  $ns at $stoptime "[set sf$i] stop"
      } else {
	  $ns at $starttime "[set sf$i] start"
	  $ns at $stoptime "[set sf$i] stop"
      }
  }
}



 for {set i 0} {$i < $flowstcp} {incr i} {
     set node_(ts$i) [$ns node]
     set node_(tk$i) [$ns node]
     $ns duplex-link $node_(ts$i) $node_(r1) 100Mb 2ms DropTail
     $ns duplex-link $node_(tk$i) $node_(r2) 100Mb [expr $i/3]ms DropTail

 #TCP_LP
 set tcp$i [$ns create-connection TCP/Reno $node_(ts$i) TCPSink $node_(tk$i) 0]
 #end TCP_LP
     [set tcp$i] set window_ 128
     [set tcp$i] set packetSize_ 1000
 #TCP_LP
     [set tcp$i] set ecn_ $ecntcp
if { $rate < 15 } { 
 #     [set tcp$i] attach $tcptr
 #     [set tcp$i] trace cwnd_
 #     [set tcp$i] trace rtt_ 
 #     [set tcp$i] trace srtt_ 
 #     [set tcp$i] trace rttvar_
}
     [set tcp$i] set ndatapack_ 0
 #end TCP_LP
 
 #TCP_LP - taken from above - here only when TCPs are here
    set sec [expr $i/10]
    set frac [expr $i%10]
    set starttime $sec.$frac
 #end TCP_LP

     set ftp$i [[set tcp$i] attach-app FTP]
     $ns at $starttime "[set ftp$i] start"
     $ns at $stoptime "[set ftp$i] stop"
 }

#$tcp0 attach $wndtr
#$tcp0 trace cwnd_

  
for {set i 0} {$i < $randomflows} {incr i} {


set node_(tsal$i) [$ns node]
set node_(tkal$i) [$ns node]
     $ns duplex-link $node_(tsal$i) $node_(r1) 100Mb 2ms DropTail
     $ns duplex-link $node_(tkal$i) $node_(r2) 100Mb [expr $i/3]ms DropTail 
set tccp$i [$ns create-connection TCP/Reno $node_(tkal$i) TCPSink $node_(tsal$i) 0]
[set tccp$i] set ecn_ 0
set ftp$i [[set tccp$i] attach-app FTP]
 $ns at $i "[set ftp$i] start"
  $ns at $stoptime "[set ftp$i] stop"  
  }

if {$freq > 0} {

set len [string length $rate]
set rate_w_mb [string range $rate 0 [expr $len-3]]
set len [string length $rate1]
set rate1_w_mb [string range $rate1 0 [expr $len-3]]

#configure cbr source
Application/Traffic/CBR set rate_ [expr $rate*0.66]Mb
set udp0 [new Agent/UDP]
set node_(scbr) [$ns node]
set node_(kcbr) [$ns node]
$ns duplex-link $node_(scbr) $node_(r1) 100Mb 2ms DropTail
$ns duplex-link $node_(kcbr) $node_(r2) 100Mb 2ms DropTail
$ns attach-agent $node_(scbr) $udp0
set cbr(0) [new Application/Traffic/CBR]
$cbr(0) attach-agent $udp0
set null0 [new Agent/Null]
$ns attach-agent $node_(kcbr) $null0
$ns connect $udp0 $null0         

proc changebw {} {
    global ns freq freq1 node_ rate rate1 queue fmon drop1 dep1 drop2 dep2 cbr
#    puts "changebw called"
    $ns at [expr [$ns now]+$freq1] "$cbr(0) start"
    $ns at [expr [$ns now]+$freq+$freq1] "changebw"
    $ns at [expr [$ns now]+$freq+$freq1] "$cbr(0) stop"
}         

$ns at 0.0 "changebw"  
}



### $ns at 15 "$fmon set pdrops_ 0; $fmon set pdepartures_ 0"


#$ns at 15 "start_counting"

if { $flowsdsp > 0 } {
 for {set i 0} {$i < $flowsdsp} {incr i} {
 $ns at 15 "[set poly$i] set ndatapack_ 0"
 }
}

if { $flowstcp > 0 } {
 for {set i 0} {$i < $flowstcp} {incr i} {
 $ns at 15 "[set tcp$i] set ndatapack_ 0"
 }
}

$ns at $stoptime "finish"

###$ns at $stoptime "printall $fmon; stop $tracefile"
#$ns at $stoptime "stop $tracefile"
#$acktrace $wndtr"



proc start_counting {} {
	global poly0 poly1
	$poly0 set ndatapack_ 0
	$poly1 set ndatapack_ 0
}



proc finish {} {

global ns flowsdsp flowstcp rnd
global poly0 poly1 poly2 poly3 poly4 poly5 poly6 poly7 poly8 poly9
global poly10 poly11 poly12 poly13 poly14 poly15 poly16 poly17 poly18 poly19
global poly20 poly21 poly22 poly23 poly24 poly25 poly26 poly27 poly28 poly29
global poly30 poly31 poly32 poly33 poly34 poly35 poly36 poly37 poly38 poly39
global poly40 poly41 poly42 poly43 poly44 poly45 poly46 poly47 poly48 poly49

global tcp0 tcp1 tcp2 tcp3 tcp4 tcp5 tcp6 tcp7 tcp8 tcp9
global tcp10 tcp11 tcp12 tcp13 tcp14 tcp15 tcp16 tcp17 tcp18 tcp19
global tcp20 tcp21 tcp22 tcp23 tcp24 tcp25 tcp26 tcp27 tcp28 tcp29
global tcp30 tcp31 tcp32 tcp33 tcp34 tcp35 tcp36 tcp37 tcp38 tcp39
global tcp40 tcp41 tcp42 tcp43 tcp44 tcp45 tcp46 tcp47 tcp48 tcp49

global data0 data1 data2 data3 data4 data5 data6 data7 data8 data9
global data10 data11 data12 data13 data14 data15 data16 data17 data18 data19
global data20 data21 data22 data23 data24 data25 data26 data27 data28 data29
global data30 data31 data32 data33 data34 data35 data36 data37 data38 data39
global data40 data41 data42 data43 data44 data45 data46 data47 data48 data49

$ns flush-trace

##$ns at 15 "$fmon set pdrops_ 0; $fmon set pdepartures_ 0"
##$ns at $stoptime "printall $fmon; stop $tracefile"
#$acktrace $wndtr"

    if { $flowsdsp > 0 } {
set sum 0.0

 for {set i 0} {$i < $flowsdsp} {incr i} {
 set data$i 0.0
 }


     for {set i 0} {$i < $flowsdsp} {incr i} {
	set data [[set poly$i] set ndatapack_]
set sum [expr $sum+$data]
set data$i $data
	puts "rnd $rnd $i xmitted $data"
     }
        if { $flowsdsp > 1 } {
#        puts "---TCP-LP totally xmitted $sum  packets ..."
puts "rnd $rnd l xmitted $sum"
set sumd 0.0
set sumu 0.0      
	for {set i 0} {$i < $flowsdsp} {incr i} {
	set data$i [expr [set data$i]/$sum]
	set sumd [expr $sumd+[set data$i]*[set data$i]]
	set sumu [expr $sumu + [set data$i]]
	}	
	set fi [expr $sumu/($flowsdsp*$sumd)]
#        puts "---TCP-LP fairness index: $fi"
         puts "rnd $rnd l fairind $fi"
	}
    }


    if { $flowstcp > 0 } {
set sum 0.0

 for {set i 0} {$i < $flowstcp} {incr i} {
 set data$i 0.0
 }


     for {set i 0} {$i < $flowstcp} {incr i} {
	set data [[set tcp$i] set ndatapack_]
set sum [expr $sum+$data]
set data$i $data
	puts "rnd $rnd $i xmitted $data"
     }
        if { $flowstcp > 1 } {
#        puts "---TCP totally xmitted $sum  packets ..."
puts "rnd $rnd t xmitted $sum"
set sumd 0.0
set sumu 0.0  
	for {set i 0} {$i < $flowstcp} {incr i} {
	set data$i [expr [set data$i]/$sum]
	set sumd [expr $sumd+[set data$i]*[set data$i]]
	set sumu [expr $sumu + [set data$i]]
	}	
	set fi [expr $sumu/($flowstcp*$sumd)]
#        puts "---TCP fairness index: $fi"
 puts "rnd $rnd t fairind $fi"
	}
    }

        exit 0
}
 




$ns run
















